summaryrefslogtreecommitdiffstats
path: root/academic/sage/sage.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'academic/sage/sage.SlackBuild')
-rw-r--r--academic/sage/sage.SlackBuild112
1 files changed, 112 insertions, 0 deletions
diff --git a/academic/sage/sage.SlackBuild b/academic/sage/sage.SlackBuild
new file mode 100644
index 0000000000..b65bfa9bb4
--- /dev/null
+++ b/academic/sage/sage.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/sh
+
+# Slackware build script for sage
+# Written by Jack Maddox <jack@auburn.edu>
+
+PRGNAM=sage
+VERSION=${VERSION:-4.7}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SAGEROOT=${SAGEROOT:-/opt/sage}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+mkdir -p $PKG/$SAGEROOT $PKG/usr/share/{applications,pixmaps} \
+ $PKG/usr/doc/$PRGNAM-$VERSION $PKG/etc/profile.d
+make
+
+# test all examples in the documentation (over 93,000 line of input)
+[ "${TEST:-no}" = "yes" ] && make test
+
+# build the pdf version of the documentation
+# (Note: this requires a LaTeX installation)
+if [ "${PDFDOC:-no}" = "yes" ]; then
+ ./sage -docbuild all pdf
+ cp -av devel/sage/doc/output/pdf $PKG/usr/doc/$PRGNAM-$VERSION
+fi
+
+# install optional packages as defined by the OPTIONALSPKG flag
+OPTIONALSPKG=${OPTIONALSPKG:-no}
+if [ "$OPTIONALSPKG" != "no" ]; then
+ for i in ${OPTIONALSPKG}; do
+ ./sage -i $(./sage -optional | grep ${i})
+ done
+fi
+
+cp -av * $PKG/$SAGEROOT
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Sage installs specific versions of a number of software components which
+# may be different from the system-wide versions of those components. For
+# this reason, the man and info pages are not moved to /usr/man and
+# /usr/info. To avoid possible conflicts, they are compressed in place.
+find $PKG/$SAGEROOT/local/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/$SAGEROOT/local/man -type l ) ; do
+ ln -s $( readlink $i ).gz $i.gz ; rm $i
+done
+find $PKG/$SAGEROOT/local/share/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/$SAGEROOT/local/share/man -type l ) ; do
+ ln -s $( readlink $i ).gz $i.gz ; rm $i
+done
+gzip -9 $PKG/$SAGEROOT/local/share/info/*.info*
+
+# Add profile scripts
+sed "s%SAGEROOT%${SAGEROOT}%" $CWD/profile.d/sage.sh > $PKG/etc/profile.d/sage.sh
+sed "s%SAGEROOT%${SAGEROOT}%" $CWD/profile.d/sage.csh > $PKG/etc/profile.d/sage.csh
+chmod 0755 $PKG/etc/profile.d/*
+
+# install scripts to SAGEROOT/bin that allow the internal sage versions of: gap,
+# gp, singular, maxima, M2, kash, mwrank, ipython, hg, and R to be run independently
+# and add SAGEROOT/bin to the PATH
+if [ "${INSTALLSCRIPTS:-no}" = "yes" ]; then
+ mkdir $PKG$SAGEROOT/bin
+ echo "install_scripts('$PKG$SAGEROOT/bin')" | ./sage
+ sed -i 's%$PATH:${SAGE_ROOT}%$PATH:${SAGE_ROOT}:${SAGE_ROOT}/bin%' $PKG/etc/profile.d/sage.sh
+ sed -i 's%$path ${SAGE_ROOT}%$path ${SAGE_ROOT} ${SAGE_ROOT}/bin%' $PKG/etc/profile.d/sage.csh
+fi
+
+cat $CWD/$PRGNAM-notebook.desktop > $PKG/usr/share/applications/$PRGNAM-notebook.desktop
+cp data/extcode/notebook/images/sageicon.png $PKG/usr/share/pixmaps/
+
+# install sagetex to a location that is accessible to the system TeX installation
+cp -a local/share/texmf $PKG/usr/share
+
+cp -a COPYING.txt README.txt $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+sed "s%SAGEROOT%${SAGEROOT}%" $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+chown -R root:root . # some ownership is not correct; this is an easy fix
+/sbin/makepkg -p -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}